zoukankan      html  css  js  c++  java
  • C. Coloring Trees DP

    传送门:http://codeforces.com/problemset/problem/711/C

    题目:

    C. Coloring Trees
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

    Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

    ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

    The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

    ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

    Please note that the friends can't color the trees that are already colored.

    Input

    The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

    The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

    Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

    Output

    Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

    Examples
    input
    3 2 2
    0 0 0
    1 2
    3 4
    5 6
    output
    10
    input
    3 2 2
    2 1 2
    1 3
    2 4
    3 5
    output
    -1
    input
    3 2 2
    2 0 0
    1 3
    2 4
    3 5
    output
    5
    input
    3 2 3
    2 1 2
    1 3
    2 4
    3 5
    output
    0
    Note

    In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

    In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

    In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

    思路:dp!dp[i][j][k]表示前i棵树中,第i棵树以涂了第j种颜色时,并此时分成了k个部分的最小花费。

      状态转移方程见代码吧,太麻烦了!

      状态转移时,只与dp[i-1][j][k]有关,之前的涂了什么颜色都不用管。

      n^4方的算法,249MS过的

    代码:

    #include <bits/stdc++.h>
    #define PB push_back
    #define MP make_pair
    using namespace std;
    typedef long long LL;
    typedef pair<int,int> PII;
    #define PI acos((double)-1)
    #define E exp(double(1))
    const int K=100+9;
    const long long maxn=1e18;
    LL v[K][K],dp[K][K][K],c[K],ans=maxn;
    int n,m,kk;
    int main(void)
    {
        cin>>n>>m>>kk;
        for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
        for(int k=0;k<=n;k++)
        dp[i][j][k]=maxn;
        for(int i=1;i<=n;i++)
            scanf("%lld",&c[i]);
        for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            scanf("%lld",&v[i][j]);
        if(c[1])
            dp[1][c[1]][1]=0;
        else
            for(int i=1;i<=m;i++)
            dp[1][i][1]=v[1][i];
        for(int i=2;i<=n;i++)
        if(c[i])
        {
            for(int j=1;j<=m;j++)
            for(int k=1;k<=n;k++)if(dp[i-1][j][k]!=maxn)
            if(j==c[i])    dp[i][c[i]][k]=min(dp[i][c[i]][k],dp[i-1][j][k]);
            else    dp[i][c[i]][k+1]=min(dp[i][c[i]][k+1],dp[i-1][j][k]);
        }
        else
        {
            for(int j=1;j<=m;j++)
            for(int k=1;k<=m;k++)
            for(int p=1;p<=n;p++)if(dp[i-1][k][p]!=maxn)
            if(k==j)dp[i][j][p]=min(dp[i][j][p],dp[i-1][k][p]+v[i][j]);
            else dp[i][j][p+1]=min(dp[i-1][k][p]+v[i][j],dp[i][j][p+1]);
        }
        for(int i=1;i<=m;i++)
            ans=min(dp[n][i][kk],ans);
        if(ans==1e18)
            printf("-1
    ");
        else
            printf("%lld
    ",ans);
        return 0;
    }
  • 相关阅读:
    GIT使用方法
    结对-结对编项目贪吃蛇-设计文档
    结对-结对编项目贪吃蛇-开发环境搭建过程
    《团队-爬取豆瓣电影TOP250-需求分析》
    《团队-爬取豆瓣电影TOP250-成员简介及分工》
    结对-结对编项目贪吃蛇-需求分析
    20170906-构建之法:阅读问题
    20170906-构建之法:现代软件工程-阅读笔记
    团队名称:极限定理
    软件工程初识
  • 原文地址:https://www.cnblogs.com/weeping/p/5822313.html
Copyright © 2011-2022 走看看